Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/expressionevaluator/FeatureAttributeElement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/expressionevaluator/FeatureAttributeElement.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/expressionevaluator/FeatureAttributeElement.java	(revision 44259)
@@ -1,16 +1,16 @@
 package org.gvsig.fmap.dal.swing.impl.expressionevaluator;
 
 import java.util.ArrayList;
+import java.util.HashMap;
 import java.util.Iterator;
 import java.util.List;
+import java.util.Map;
+import java.util.Objects;
 import org.apache.commons.lang3.StringUtils;
 import org.gvsig.expressionevaluator.Function;
-import org.gvsig.expressionevaluator.SymbolTable;
 import org.gvsig.expressionevaluator.swing.Element;
 import org.gvsig.expressionevaluator.swing.Element.GroupElement;
 import org.gvsig.expressionevaluator.swing.Element.SimpleElement;
-import org.gvsig.expressionevaluator.swing.Element.VariableElement;
-import org.gvsig.expressionevaluator.swing.ExpressionBuilderConfig;
 import org.gvsig.expressionevaluator.swing.spi.AbstractElement;
 import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingLocator;
 import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingManager;
@@ -18,9 +18,11 @@
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureSet;
 import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.dal.swing.impl.searchpanel.SearchUtils;
 import org.gvsig.tools.ToolsLocator;
 import org.gvsig.tools.exception.BaseException;
 import org.gvsig.tools.i18n.I18nManager;
+import org.gvsig.tools.util.LabeledValue;
 import org.gvsig.tools.visitor.VisitCanceledException;
 import org.gvsig.tools.visitor.Visitor;
 
@@ -28,23 +30,20 @@
  *
  * @author jjdelcerro
  */
-public class FeatureAttributeElement        
+public class FeatureAttributeElement
         extends AbstractElement
-        implements 
-            GroupElement,
-            SimpleElement,
-            VariableElement
-{
+        implements
+        GroupElement,
+        SimpleElement
+    {
 
     final FeatureStore store;
     final FeatureAttributeDescriptor attrdesc;
     List<Element> elements;
-    final ExpressionBuilderConfig config;
-    boolean hasMoreElements; 
-    
-    FeatureAttributeElement(ExpressionBuilderConfig configPanel, FeatureStore store, FeatureAttributeDescriptor attrdesc) {
-        super(attrdesc.getName(), "expressionbuilder-element-table-field");
-        this.config = configPanel;
+    boolean hasMoreElements;
+
+    FeatureAttributeElement(FeatureStore store, FeatureAttributeDescriptor attrdesc) {
+        super(attrdesc.getName(), attrdesc.getName(), "expressionbuilder-element-table-field");
         this.store = store;
         this.attrdesc = attrdesc;
         this.elements = null;
@@ -52,19 +51,14 @@
     }
 
     @Override
-    public String getTypeName() {
-        return this.attrdesc.getDataTypeName();
-    }
-
-    @Override
     public Element get(int index) {
         return this.getElements().get(index);
     }
-    
+
     @Override
     public boolean isEnabled() {
-        if( this.config.isSQLCompatible() ) {
-            if( this.attrdesc.isComputed() ) {
+        if (this.getConfig().getPreferences().isSQLCompatible()) {
+            if (this.attrdesc.isComputed()) {
                 return false;
             }
         }
@@ -93,41 +87,59 @@
 
     @Override
     public void reload() {
-        this.elements=null; 
+        this.elements = null;
         hasMoreElements = false;
     }
 
     @Override
     public List<Element> getElements() {
-        if( this.elements==null ) {
+        if (this.elements == null) {
             hasMoreElements = false;
             ExpressionEvaluatorSwingManager manager = ExpressionEvaluatorSwingLocator.getManager();
             final List<Object> values = new ArrayList<>();
-            final int limit = this.config==null? 60 : this.config.getSimpleElementsLimit();
-            final long timeLimit = System.currentTimeMillis() + limit*1000;
+            final int limit = this.getConfig() == null ? 60 : this.getConfig().getPreferences().getSimpleElementsLimit();
+            final long timeLimit = System.currentTimeMillis() + limit * 1000;
             try {
                 FeatureSet set = this.store.getFeatureSet();
                 set.accept(new Visitor() {
                     @Override
                     public void visit(Object o) throws VisitCanceledException, BaseException {
-                        Object value = ((Feature)o).get(attrdesc.getName());
-                        if( !values.contains(value ) ) {
+                        Object value = ((Feature) o).get(attrdesc.getName());
+                        if (!values.contains(value)) {
                             values.add(value);
                         }
-                        if( System.currentTimeMillis() > timeLimit ) {
+                        if (System.currentTimeMillis() > timeLimit) {
                             hasMoreElements = true;
                             throw new VisitCanceledException();
                         }
                     }
                 });
-            } catch(VisitCanceledException ex) {
-                
+            } catch (VisitCanceledException ex) {
+
             } catch (Exception ex) {
                 // FIXME
             }
             this.elements = new ArrayList<>();
-            for (Object value : values) {
-                this.elements.add(manager.createConstantElement(this.config, value));
+            if (!values.isEmpty()) {
+                LabeledValue[] availableValues = this.attrdesc.getAvailableValues();
+                Map<String, String> availableValuesMap = new HashMap<>();
+                if( availableValues!=null ) {
+                    for (LabeledValue availableValue : availableValues) {
+                        availableValuesMap.put(
+                                Objects.toString(availableValue.getValue()),
+                                availableValue.getLabel()
+                        );
+                    }
+                }
+                for (Object value : values) {
+                    String key = Objects.toString(value);
+                    String label = availableValuesMap.getOrDefault(key, null);
+                    this.elements.add(manager.createConstantElement(
+                            value,
+                            label
+                        )
+                    );
+                }
             }
         }
         return this.elements;
@@ -139,18 +151,28 @@
     }
 
     @Override
-    public String getSource() {
-        return this.store.getName();
+    public boolean hasMoreElements() {
+        return this.hasMoreElements;
     }
 
     @Override
+    public String getName() {
+        return attrdesc.getName();
+    }
+    
+    @Override
     public String getLabel() {
-        return "Field";
+        if (getConfig().getPreferences().getShowLabelsOfElements()) {
+            if (!StringUtils.equals(attrdesc.getName(), attrdesc.getLabel())) {
+                return "<html>" + attrdesc.getLabel() + "<br><font size=\"2\"><i>(" + attrdesc.getName() + ")</i></font></html>";
+            }
+        }
+        return "<html>" + attrdesc.getName() + "</html>";
     }
 
     @Override
-    public boolean hasMoreElements() {
-        return this.hasMoreElements;
+    public String getRenderedValue() {
+        return " "+attrdesc.getName()+" ";
     }
 
     @Override
@@ -161,17 +183,21 @@
         html.append("<html>\n");
 
         html.append("<b>").append(this.getLabel()).append("</b><br>\n<br>\n");
-        html.append("<b>").append(i18n.getTranslation("_Source")).append("</b> ").append(this.getSource()).append("<br>\n");
+        html.append("<b>").append(i18n.getTranslation("_Source")).append("</b> ").append(this.store.getName()).append("<br>\n");
         html.append("<b>").append(i18n.getTranslation("_Name")).append("</b> ").append(this.getName()).append("<br>\n");
-        html.append("<b>").append(i18n.getTranslation("_Type")).append("</b> ").append(this.getTypeName()).append("<br>\n");
-        if( !StringUtils.isBlank(this.attrdesc.getDescription()) &&
-                StringUtils.equalsAnyIgnoreCase(this.getName(), this.attrdesc.getDescription()) ) {
+        html.append("<b>").append(i18n.getTranslation("_Type")).append("</b> ").append(this.attrdesc.getDataTypeName()).append("<br>\n");
+        if (!StringUtils.isBlank(this.attrdesc.getDescription())
+                && StringUtils.equalsAnyIgnoreCase(this.getName(), this.attrdesc.getDescription())) {
             html.append("<b>").append(i18n.getTranslation("_Description")).append("</b><br>\n");
             html.append(this.attrdesc.getDescription().replace("\n", "<br>")).append("<br>\n");
         }
         html.append("</html>\n");
         return html.toString();
     }
-    
-    
+
+    @Override
+    @SuppressWarnings("empty-statement")
+    public void used() {
+        SearchUtils.getRecentUseds().add(attrdesc);
+    }
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/expressionevaluator/FeatureStoreElementFactory.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/expressionevaluator/FeatureStoreElementFactory.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/expressionevaluator/FeatureStoreElementFactory.java	(revision 44259)
@@ -23,9 +23,8 @@
 
     @Override
     public Element createElement(Object... parameters) {
-        ExpressionBuilderConfig config = (ExpressionBuilderConfig) parameters[0];
-        FeatureStore store = (FeatureStore) parameters[1];
-        Element e = new DefaultFeatureStoreElement(config, store);
+        FeatureStore store = (FeatureStore) parameters[0];
+        Element e = new DefaultFeatureStoreElement(store);
         return e;
     }
     
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/test/java/org/gvsig/fmap/dal/feature/DummyFetureStore.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/test/java/org/gvsig/fmap/dal/feature/DummyFetureStore.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/test/java/org/gvsig/fmap/dal/feature/DummyFetureStore.java	(revision 44259)
@@ -2,7 +2,6 @@
 package org.gvsig.fmap.dal.feature;
 
 import java.util.Collection;
-import java.util.Collections;
 import java.util.Iterator;
 import java.util.List;
 import java.util.Set;
@@ -17,6 +16,7 @@
 import org.gvsig.fmap.dal.DataStore;
 import org.gvsig.fmap.dal.DataStoreParameters;
 import org.gvsig.fmap.dal.DataStoreProviderFactory;
+import org.gvsig.fmap.dal.StoresRepository;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.exception.ValidateDataParametersException;
 import org.gvsig.fmap.dal.feature.exception.NeedEditingModeException;
@@ -36,6 +36,7 @@
 import org.gvsig.tools.undo.UndoException;
 import org.gvsig.tools.util.ResourcesStorage;
 import org.gvsig.tools.util.ResourcesStorageEmpty;
+import org.gvsig.tools.util.UnmodifiableBasicMap;
 import org.gvsig.tools.visitor.Visitor;
 
 /**
@@ -403,11 +404,6 @@
     }
 
     @Override
-    public Iterator getChildren() {
-        return null;
-    }
-
-    @Override
     public DataServerExplorer getExplorer() throws DataException, ValidateDataParametersException {
         return null;
     }
@@ -753,18 +749,13 @@
     }
 
     @Override
-    public DataStore getChild(String name) {
+    public StoresRepository getStoresRepository() {
         return null;
     }
 
     @Override
-    public List<String> getChildrenNames() {
-        return Collections.EMPTY_LIST;
+    public UnmodifiableBasicMap<String, DataStore> getChildren() {
+        return UnmodifiableBasicMap.EMPTY_UNMODIFIABLEBASICMAP;
     }
 
-    @Override
-    public boolean hasChildren() {
-        return false;
-    }
-
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/DataManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/DataManager.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/DataManager.java	(revision 44259)
@@ -71,6 +71,13 @@
     public static final String  DAL_SYMBOL_TABLE = "DAL.SymbolTable";
     public static final String  FEATURE_SYMBOL_TABLE = "DAL.FeatureSymbolTable";
 
+    public static final String DAL_FOREING_CODE = "DAL.foreingCode";
+    public static final String DAL_FOREING_TABLE = "DAL.foreingTable";
+    public static final String DAL_FOREING_LABEL = "DAL.foreingLabel";
+
+    public static final String DAL_FOREING_KEY = "DAL.ForeingKey";
+    public static final String DAL_SELECTABLE_FOREING_KEY = "DAL.SelectableForeingKey";
+    
     /**
      * Returns the default DAL's temporary directory
      *
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/feature/FeatureStore.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/feature/FeatureStore.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/feature/FeatureStore.java	(revision 44259)
@@ -33,6 +33,7 @@
 import org.gvsig.fmap.dal.DataServerExplorer;
 import org.gvsig.fmap.dal.DataStore;
 import org.gvsig.fmap.dal.DataStoreParameters;
+import org.gvsig.fmap.dal.StoresRepository;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.exception.ReadException;
 import org.gvsig.fmap.dal.feature.exception.FeatureIndexException;
@@ -933,4 +934,6 @@
     
     public ResourcesStorage getResourcesStorage();
     
+    public StoresRepository getStoresRepository();
+    
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/DataStore.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/DataStore.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/DataStore.java	(revision 44259)
@@ -40,6 +40,8 @@
 import org.gvsig.tools.observer.Observer;
 import org.gvsig.tools.persistence.Persistent;
 import org.gvsig.tools.service.spi.Services;
+import org.gvsig.tools.util.UnmodifiableBasicList;
+import org.gvsig.tools.util.UnmodifiableBasicMap;
 import org.gvsig.tools.visitor.Visitable;
 import org.gvsig.tools.visitor.Visitor;
 
@@ -268,16 +270,14 @@
 	public DataSet createSelection() throws DataException;
 
 	/**
-	 * Returns an iterator over this store children
+	 * Returns an UnmodifiableBasicMap with this store children.
+         * If do not have children, return an empty map.
+         * Never returns null.
 	 *
-	 * @return Iterator over this DataStore children
+	 * @return an UnmodifiableBasicMap with this DataStore children
 	 */
-	public Iterator<DataStore> getChildren();
+	public UnmodifiableBasicMap<String,DataStore> getChildren();
         
-        public DataStore getChild(String name);
-        
-        public List<String> getChildrenNames();
-        
 
 	/**
 	 * Returns the DataServerExplorer to which this DataStore belongs, if there
@@ -342,7 +342,5 @@
      */
     public DataCache getCache();
 
-    public boolean hasChildren();
-
 }
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/AbstractFeatureStoreProvider.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/AbstractFeatureStoreProvider.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/AbstractFeatureStoreProvider.java	(revision 44259)
@@ -69,6 +69,7 @@
 import org.gvsig.tools.dynobject.exception.DynFieldNotFoundException;
 import org.gvsig.tools.dynobject.exception.DynMethodException;
 import org.gvsig.tools.exception.BaseException;
+import org.gvsig.tools.util.UnmodifiableBasicMap;
 
 /**
  * Abstract implementation of {@link FeatureStoreProvider}
@@ -480,30 +481,24 @@
 	 *
 	 * @see org.gvsig.fmap.dal.feature.spi.FeatureStoreProvider#supportsAppendMode()
 	 */
+        @Override
 	public boolean supportsAppendMode() {
 		return false;
 	}
 
         @Override
-	public Iterator<DataStore> getChildren() {
-		return Collections.EMPTY_LIST.iterator();
+	public UnmodifiableBasicMap<String,DataStore> getChildren() {
+		return UnmodifiableBasicMap.EMPTY_UNMODIFIABLEBASICMAP;
 	}
 
-        @Override
-        public DataStore getChild(String name) {
-            return null;
-        }
-
-        @Override
-        public boolean hasChildren() {
-            return false;
-        }
-
 	/**
 	 * unsupported by default (return null), override this otherwise
 	 *
+         * @throws org.gvsig.fmap.dal.exception.ReadException
+         * @throws org.gvsig.fmap.dal.exception.ValidateDataParametersException
 	 * @see org.gvsig.fmap.dal.spi.DataStoreProvider#getExplorer()
 	 */
+        @Override
 	public DataServerExplorer getExplorer() throws ReadException,
 			ValidateDataParametersException {
 		return null;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/spi/DataStoreProvider.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/spi/DataStoreProvider.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/spi/DataStoreProvider.java	(revision 44259)
@@ -24,7 +24,6 @@
 package org.gvsig.fmap.dal.spi;
 
 import java.util.Collection;
-import java.util.Iterator;
 
 import org.gvsig.fmap.dal.DataServerExplorer;
 import org.gvsig.fmap.dal.DataStore;
@@ -39,6 +38,7 @@
 import org.gvsig.timesupport.Time;
 import org.gvsig.tools.dispose.Disposable;
 import org.gvsig.tools.dynobject.DynObject_v2;
+import org.gvsig.tools.util.UnmodifiableBasicMap;
 
 /**
  * Base interface for all data providers
@@ -49,16 +49,14 @@
 public interface DataStoreProvider extends org.gvsig.fmap.dal.DataStoreProvider, DynObject_v2, Disposable {
 
 	/**
-	 * Retruns an {@link java.util.Iterator} of SubStores from this store. it
-	 * this hasn't SubStores returns <code>null</code>.
+	 * Returns an UnmodifiableBasicMap with subStores from this store.
+         * If do not have children, return an empty UnmodifiableBasicMap.
+         * Never returns null.
 	 *
-	 * @return SubStores iterator
+	 * @return SubStores UnmodifiableBasicMap
 	 */
-	public Iterator<DataStore> getChildren();
+	public UnmodifiableBasicMap<String,DataStore> getChildren();
 
-        public DataStore getChild(String name);
-
-        public boolean hasChildren();
 	/**
 	 * Create a {@link DataServerExplorer} from the same source that this store.
 	 *
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.lib/src/main/java/org/gvsig/fmap/dal/serverexplorer/filesystem/impl/DefaultFilesystemServerExplorer.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.lib/src/main/java/org/gvsig/fmap/dal/serverexplorer/filesystem/impl/DefaultFilesystemServerExplorer.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.lib/src/main/java/org/gvsig/fmap/dal/serverexplorer/filesystem/impl/DefaultFilesystemServerExplorer.java	(revision 44259)
@@ -576,7 +576,7 @@
         if (rootPathName == null) {
             return null;
         }
-        if( dataStore.hasChildren() ) {
+        if( !dataStore.getChildren().isEmpty() ) {
             FileMultiResource res = new FileMultiResource(
                     new File(rootPathName),
                     dataStore.getName(), 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.lib/src/main/java/org/gvsig/fmap/dal/feature/spi/simpleprovider/SimpleSequentialReaderStoreProvider.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.lib/src/main/java/org/gvsig/fmap/dal/feature/spi/simpleprovider/SimpleSequentialReaderStoreProvider.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.lib/src/main/java/org/gvsig/fmap/dal/feature/spi/simpleprovider/SimpleSequentialReaderStoreProvider.java	(revision 44259)
@@ -26,13 +26,11 @@
 import java.io.File;
 import java.io.IOException;
 import java.util.ArrayList;
-import java.util.Collections;
 import java.util.HashMap;
 import java.util.Iterator;
 import java.util.List;
 import java.util.Locale;
 import java.util.Map;
-import org.apache.commons.io.FilenameUtils;
 
 import org.apache.commons.lang3.StringUtils;
 import org.cresques.cts.IProjection;
@@ -87,6 +85,9 @@
 import org.gvsig.tools.exception.BaseException;
 import org.gvsig.tools.task.SimpleTaskStatus;
 import org.gvsig.tools.task.TaskStatusManager;
+import org.gvsig.tools.util.UnmodifiableBasicMap;
+import org.gvsig.tools.util.UnmodifiableBasicMapToMapAdapter;
+import org.gvsig.tools.util.UnmodifiableBasicSet;
 import org.gvsig.tools.visitor.VisitCanceledException;
 import org.gvsig.tools.visitor.Visitor;
 import org.slf4j.Logger;
@@ -101,7 +102,7 @@
     private class ReaderData {
         private FeatureType defaultFeatureType;
         private List<FeatureType> featureTypes;
-        private List<FeatureProvider> features;
+        private final List<FeatureProvider> features;
         private boolean needCalculateEnvelope;
         private String name;
         private long OIDcounter;
@@ -172,7 +173,103 @@
             return this.store;
         }
     }
+    
+    class Children implements UnmodifiableBasicMap<String, DataStore> {
+        // Con esta clase se pospone la creacion de los stores hasta que se 
+        // pide cada uno de ellos, y no cuando se pide el Map de estos, ya
+        // que el map se puede pedir solo para saber si hay o cuantos hay.
 
+        @Override
+        public DataStore get(String key) {
+            for (ReaderData child : childrenData) {
+                if( StringUtils.equalsIgnoreCase(child.getName(), key) ) {
+                    try {
+                        return child.getStore();
+                    } catch (Exception ex) {
+                        throw new RuntimeException(ex);
+                    }
+                }
+            }
+            return null;
+        }
+
+        @Override
+        public boolean isEmpty() {
+            return childrenData.isEmpty();
+        }
+
+        @Override
+        public boolean containsKey(String key) {
+            for (ReaderData child : childrenData) {
+                if( StringUtils.equalsIgnoreCase(child.getName(), key) ) {
+                    return true;
+                }
+            }
+            return false;
+        }
+
+        @Override
+        public Map<String, DataStore> toMap() {
+            return new UnmodifiableBasicMapToMapAdapter<>(this);
+        }
+
+        @Override
+        public int size() {
+            return childrenData.size();
+        }
+
+        @Override
+        public UnmodifiableBasicSet<String> keySet() {
+            return new UnmodifiableBasicSet<String>() {
+
+                @Override
+                public boolean isEmpty() {
+                    return childrenData.isEmpty();
+                }
+
+                @Override
+                public int size() {
+                    return childrenData.size();
+                }
+
+                @Override
+                public Iterator<String> iterator() {
+                    final Iterator<ReaderData> it = childrenData.iterator();
+                    return new Iterator<String>() {
+                        @Override
+                        public boolean hasNext() {
+                            return it.hasNext();
+                        }
+
+                        @Override
+                        public String next() {
+                            ReaderData theReaderData = it.next();
+                            return theReaderData.getName();
+                        }
+                    };
+                }
+            };
+        }
+
+        @Override
+        public Iterator<DataStore> iterator() {
+            final Iterator<String> it = this.keySet().iterator();
+            return new Iterator<DataStore>() {
+                @Override
+                public boolean hasNext() {
+                    return it.hasNext();
+                }
+
+                @Override
+                public DataStore next() {
+                    String name = it.next();
+                    return get(name);
+                }
+            };
+        }
+        
+    }
+
     private final ResourceProvider resource;
 
     private Envelope envelope;
@@ -180,7 +277,7 @@
     private final SimpleTaskStatus taskStatus;
     private String name = "";
     private final SimpleSequentialReaderFactory readerFactory;
-    private final List<ReaderData> childrenData;
+    private List<ReaderData> childrenData;
     private ReaderData readerData;
 
     public SimpleSequentialReaderStoreProvider(
@@ -217,6 +314,9 @@
         );
 
         resource.addConsumer(this);
+        if( this.readerData!=null ) {
+            this.name = this.readerData.getName();            
+        }
         if( storeServices != null ) {
             initializeFeatureTypes();
         }
@@ -547,7 +647,7 @@
                             break;
                         }
                     default:
-                        LOGGER.warn("Illegal argumente '"+option+"' in '"+getProviderName()+"' file '" + getFullFileName() + "'.");
+                        LOGGER.warn("Illegal argumente '"+option+"' for field '"+this.name+"' in '"+getProviderName()+"' file '" + getFullFileName() + "' ("+value+").");
                 }
             }
             return true;
@@ -820,7 +920,7 @@
             SimpleSequentialReader reader = this.readerFactory.createReader(this.getParameters());
             try {
                 loadFeatures(reader, theReaderData);
-
+                this.childrenData = new ArrayList<>();
                 for(SimpleSequentialReader childReader : reader.getChildren() ) {
                     ReaderData childData = new ReaderData();
                     loadFeatures(childReader, childData);
@@ -832,8 +932,8 @@
             }
         }
         this.name = theReaderData.getName();
-        FeatureStoreProviderServices store = this.getStoreServices();
-        store.setFeatureTypes(theReaderData.getFeatureTypes(), theReaderData.getDefaultFeatureType());
+        FeatureStoreProviderServices theStore = this.getStoreServices();
+        theStore.setFeatureTypes(theReaderData.getFeatureTypes(), theReaderData.getDefaultFeatureType());
         this.need_calculate_envelope = theReaderData.getNeedCalculateEnvelope();
         this.data = theReaderData.getFeatures();
 
@@ -1001,38 +1101,8 @@
     }
 
     @Override
-    public DataStore getChild(String name) {
-        for (ReaderData childData : this.childrenData) {
-            if( StringUtils.equalsIgnoreCase(name, childData.getName()) ) {
-                try {
-                    return childData.getStore();
-                } catch (InitializeException ex) {
-                    throw new RuntimeException("Can't acces to child '"+name+"'", ex);
-                }
-            }
-        }        
-        return null;
+    public UnmodifiableBasicMap<String, DataStore> getChildren() {
+        return new Children();
     }
-    
-    @Override
-    public Iterator<DataStore> getChildren() {
-        if( this.childrenData==null || this.childrenData.isEmpty() ) {
-            return Collections.EMPTY_LIST.iterator();
-        }
-        try {
-            List<DataStore> children = new ArrayList<>();
-            for (ReaderData childData : this.childrenData) {
-                    children.add(childData.getStore());
-            }
-            return children.iterator();
-        } catch (InitializeException ex) {
-            throw new RuntimeException("Can't access to children", ex);
-        }
-    }
 
-    @Override
-    public boolean hasChildren() {
-        return this.childrenData!=null && !this.childrenData.isEmpty();
-    }
-    
 }
